#include <stdio.h>

#include "cap4.h"

Point::Point()
// constructor implicit
{
  x = 0;
  y = 0;
}

Point::Point(unsigned X, unsigned Y)
{
  x = X;
  y = Y;
}

Point::Point(Point &p)
{
  p.x = x;
  p.y = y;
}

Point::~Point()
{
}

unsigned Point::GetX()
{
  return x;
}

unsigned Point::GetY()
{
  return y;
}

void Point::SetX(unsigned X)
{
  x = X;
}

void Point::SetY(unsigned Y)
{
  y = Y;
}

unsigned long Point::Arie()
{
  return this->x * this->y;
}

Point& Point::operator += (Point __p)
{
  x += __p.x;
  y += __p.y;
  return *this;
}

Point& Point::operator -= (Point __p)
{
  x -= __p.x;
  y -= __p.y;
  return *this;
}

Point Point::operator + (Point __p)
{
  return Point(x + __p.x, y + __p.y);
}

Point Point::operator - (Point __p)
{
  return Point(x - __p.x, y - __p.y);
}

int Point::operator == (Point __p)
{
  return x == __p.x && y == __p.y;
}

int Point::operator != (Point __p)
{
  return !(*this == __p);
}

int Point::operator < (Point __p)
{
  return x < __p.x && y < __p.y;
}

int Point::operator > (Point __p)
{
  return x > __p.x && y > __p.y;
}

int Point::operator <= (Point __p)
{
  return x <= __p.x && y <= __p.y;
}

int Point::operator >= (Point __p)
{
  return x >= __p.x && y >= __p.y;
}

Point& Point::operator = (Point __p)
{
  x = __p.x;
  y = __p.y;
  return *this;
}

GraphicPoint::GraphicPoint(unsigned X, unsigned Y, unsigned Color) : Point(X, Y)
{
  color = Color;
}

GraphicPoint::~GraphicPoint()
{
}

void GraphicPoint::Draw()
{
  // ...
  // apelare primitive grafice pentru desenarea efectiva a punctului
}

void GraphicPoint::SetX(unsigned X)
{
  Point::SetX(X); // apelul functiei SetX() apartinand clasei de baza
  Draw();
}

void GraphicPoint::SetY(unsigned Y)
{
  Point::SetY(Y);
  Draw();
}

void main()
{
  Point *p = new Point;
//  p->x = 5;   // operatie imposibila: x este membru privat
//  p->y = 8;   // operatie imposibila: y este membru privat
  p->SetX(5);   // corect: acces la variabila x prin intermediul functiei
  p->SetY(8);
  printf("Aria = %d\n", p->Arie());
  delete p;
}
